{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
{    Unit permettant de tester l'alignement de 4 pions conscutifs   }
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
unit GestionAlignement;

interface
uses
  Dialogs, Sysutils, ExtCtrls;
procedure DessinJoueurGagnant(lig, col, dl, dc : Integer; imgGagnant : TImage);
function TestAlignement : Boolean;

implementation
uses
  UnitePrincipale;
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
{    Dessiner les 4 jetons du joueur gagnant avec une autre couleur   }
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
procedure DessinJoueurGagnant(lig, col, dl, dc: Integer; imgGagnant : TImage);
var
  dep, pos, curLig, curCol : Integer;
begin
  curLig := lig;
  curCol := col;
  for dep := 1 to 4 do
  begin
    pos := ((curLig - 1) * 7) + curCol + 41;
    TImage(Form1.GroupBox3.Controls[pos]).Picture := imgGagnant.Picture;
    curLig := curLig + dl;
    curCol := curCol + dc;
  end;
  if imgGagnant = jetonJaune then
  begin
    Form1.GroupBox1.Font.Color := COULEUR_JAUNE;
    Form1.GroupBox2.Font.Color := COULEUR_NOIRE;
  end
  else
  begin
    Form1.GroupBox1.Font.Color := COULEUR_NOIRE;
    Form1.GroupBox2.Font.Color := COULEUR_VERTE;
  end;
end;
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
{            La valeur d'un pion est 1, 2 ou 0                        }
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
function ValeurPion(lig, col : Integer) : Integer;
begin
   if (lig < 1) or (lig > NB_LIGNE) or
   (col < 1) or (col > NB_COLONNE) then
     result := 0
   else
     result := grille[lig, col];
end;
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
{            Tester un alignement selon la direction                  }
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
function VerifieDirection(lig, col, dl, dc : Integer) : Integer;
var
  position, joueur, curLig, curCol, pion : Integer;
  total                                  : array[1..2] of Integer;
  gagne                                  : Boolean;
begin
  curLig := lig;
  curCol := col;

  for joueur := 1 to 2 do
    total[joueur] := 0;
  for position := 1 to 4 do
  begin
    pion := ValeurPion(curLig, curCol);
    if pion > 0 then
      total[pion] := total[pion] + 1;
    curLig := curLig + dl;
    curCol := curCol + dc;
  end;
  joueur := 1;
  gagne := false;
  while (joueur <= 2) and (not gagne) do
  begin
    if total[joueur] = 4 then
    begin
      gagne := true;
      if joueur = 1 then
        DessinJoueurGagnant(lig, col, dl, dc, jetonJaune)
      else
        DessinJoueurGagnant(lig, col, dl, dc, jetonVert);
    end
    else
      joueur := joueur + 1;
  end;
  if gagne then
    result := joueur
  else
    result := 0;
end;
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
{           Tester l'alignement dans les 4 directions                 }
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
function TestAlignement : Boolean;
var
  lig, col, dl, dc, dir, numJoueurGagnant : Integer;
begin
  result := false;
 numJoueurGagnant := 0;
 lig := NB_LIGNE;
 while (lig >= 1) and (numJoueurGagnant = 0) do
 begin
   col := 1;
   while (col <= NB_COLONNE) and (numJoueurGagnant = 0) do
   begin
     dir := 1;
     while (dir <= 4) and (numJoueurGagnant = 0) do
     begin
       dl := directions[dir, 1];
       dc := directions[dir, 2];
       numJoueurGagnant := VerifieDirection(lig, col, dl, dc);
       dir := dir + 1;
     end;
     col := col + 1;
   end;
   lig := lig - 1;
 end;
 if numJoueurGagnant = 1 then
 begin
   ShowMessage('  Bravo! le joueur n 1 a gagn  ');
   Form1.DesactiverPlateau;
   result := true;
 end
 else
   if numJoueurGagnant = 2 then
   begin
     ShowMessage('  Bravo! le joueur n 2 a gagn  ');
     Form1.DesactiverPlateau;
     result := true;
   end;
end;
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
{                  Fin de l'unit Gestion Alignement                  }
{~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~=~}
end.














